<?php
/**
* Module Info Delivery
*
* @author FlorianV
* @copyright (C) 2012 - Florian Voutzinos
* @email: voutzinos.florian|at|gmail.com
*
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
*/

defined('_JEXEC') or die('Restricted access');
 
require_once( dirname(__FILE__).DS.'helper.php' );

$shippedOrders = ModInfoDeliveryHelper::getUserShippedOrders();

// No shipped orders for this user
if (!$shippedOrders)
	$finalOrders = false;

else
{
	// Loading params from backend
	$deliveryTime = (int)$params->get('deliverytime'); // hour
	$openedFrom = (float)$params->get('openedfrom'); // decimal and 24 hour system
	$openedTo = (float)$params->get('openedto');
	$monday = (bool)$params->get('monday');
	$tuesday = (bool)$params->get('tuesday');
	$wednesday = (bool)$params->get('wednesday');
	$thursday = (bool)$params->get('thursday');
	$friday = (bool)$params->get('friday');
	$saturday = (bool)$params->get('saturday');
	$sunday = (bool)$params->get('sunday');
	$dateFormat = (int)$params->get('dateformat');
	$advancedDateFormat = (string)$params->get('advancedateformat');
	
	$anyProblem = ModInfoDeliveryHelper::detectProblems($deliveryTime, $openedFrom, $openedTo, $monday, $tuesday, $wednesday, $thursday, $friday, $saturday, $sunday);
	
	if ($anyProblem)
		$finalOrders = false;
	
	else
	{
		// Working
		$openedFromArray = ModInfoDeliveryHelper::decimalToTime($openedFrom);
		$openedToArray = ModInfoDeliveryHelper::decimalToTime($openedTo);
		$weekArray = ModInfoDeliveryHelper::createWeekArray($monday, $tuesday, $wednesday, $thursday, $friday, $saturday, $sunday);
	
		$i = 0;
	
		foreach ($shippedOrders as $shippedOrder)
		{
			$receiptDate[$i] = ModInfoDeliveryHelper::parseDate($shippedOrder, $deliveryTime, $openedFromArray, $openedToArray, $weekArray);
		
			if ($receiptDate[$i])
			{
				$receiptDate[$i] = ModInfoDeliveryHelper::formatDate($receiptDate[$i], $dateFormat, $advancedDateFormat);
				$finalOrders[$i] = ModInfoDeliveryHelper::createShippedOrderObject($shippedOrder->virtuemart_order_id, $shippedOrder->order_number,  				$shippedOrder->order_name, $receiptDate[$i]);
				$i++;
			}
		}
	}
}

require(JModuleHelper::getLayoutPath('mod_info_delivery'));